/**
 * @package css-modules-types-loader
 * @license MIT
 * @version 0.3.25
 * @author nuintun <nuintun@qq.com>
 * @description A webpack loader that dynamically generates TypeScript typings for CSS modules from css-loader.
 * @see https://github.com/nuintun/css-modules-types-loader#readme
 */

'use strict';

const threads = require('threads');

/**
 * @module index
 */
const pool = threads.Pool(() => {
  return threads.spawn(new threads.Worker('./generate.cjs'));
});
async function terminate(force) {
  return pool.terminate(force);
}
async function generate(path, content, options) {
  pool.queue(async generate => {
    await generate(path, content.toString(), options);
  });
  await pool.completed();
}

exports.generate = generate;
exports.terminate = terminate;
