/**
 * @package css-modules-types-loader
 * @license MIT
 * @version 0.3.25
 * @author nuintun <nuintun@qq.com>
 * @description A webpack loader that dynamically generates TypeScript typings for CSS modules from css-loader.
 * @see https://github.com/nuintun/css-modules-types-loader#readme
 */

import { expose } from 'threads';
import { generateTypings, writeFile, removeFile } from './utils.js';

/**
 * @module generate
 */
expose(async function generate(path, content, options = {}) {
  const typings = generateTypings(content, options.banner, options.eol);
  if (typings) {
    return writeFile(path, typings);
  } else {
    return removeFile(path);
  }
});
